--
-- JD7RSeries
-- Specialization class for JD7RSeries
-- @Authors of original scripts used: Manuel Leithner (SFM-Modding),Modelleicher (www.schwabenmodding.bplaced.net),Templaer, JoXXer, Knagsted, Mofa-Killer, Face, Heady, other do not remember!!
-- @author  Ago-Systemtech
-- 
-- @DATE  24/12/14 ADD FIX FOR USE JD 7R SERIES, FS15 Ago-Systemtech(alias Ago-Modding): https://www.facebook.com/ago.systemtech (Modhoster Team)
------ free for non commercial-usage -------------

JD7RSeries = {};
function JD7RSeries.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Motorized, specializations);
end;
function JD7RSeries:load(xmlFile)

	---------------------CAM INTERNA MOBILE---------------------
	self.internalCamera = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.internalCamera#index"));
	self.camPositionX = 0;
	self.camPositionZ = 0;
	self.camPositionY = 0;
		
	self.FrizioneFrenoRotation = SpecializationUtil.callSpecializationsFunction("FrizioneFrenoRotation");
	
	self.updateFuelIndicators = SpecializationUtil.callSpecializationsFunction("updateFuelIndicators");
	self.ledriserva = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.ledriserva#index"));
	self.ledriservaActive = false;
	self.riserva = 60;
	------------REALISTIC INDOOR CAM------------
	self.ric = {};
	self.ric.directionPart = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.realisticIndoorCam#directionPart"));
		
	--------------------Sound Inversore-------------------
	InversoreDirectionSoundFile = Utils.getFilename("Sound/gearShift.wav", self.baseDirectory);
	self.InversoreDirectionSoundId = createSample("InversoreDirectionSound");
    loadSample(self.InversoreDirectionSoundId, InversoreDirectionSoundFile, false);
    self.InversoreDirectionPlaying = false;
	
	self.isSelectable = true;
	----------------------- FRONT WIPER ANIMATION---------------------
	local wiperFrontAnimRootNode = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.wiperFront#rootNode"));
	self.wiperFrontAnimCharSet = 0;
	if wiperFrontAnimRootNode ~= nil and wiperFrontAnimRootNode ~= 0 then
		self.wiperFrontAnimCharSet = getAnimCharacterSet(wiperFrontAnimRootNode);
		if self.wiperFrontAnimCharSet ~= 0 then
			local clip = getAnimClipIndex(self.wiperFrontAnimCharSet, getXMLString(xmlFile, "vehicle.wiperFront#clip"));
			assignAnimTrackClip(self.wiperFrontAnimCharSet, 0, clip);
			setAnimTrackLoopState(self.wiperFrontAnimCharSet, 0, true);
			local wiperFrontAnimSpeedScale = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.wiperFront#speedScale"), 1);
			setAnimTrackSpeedScale(self.wiperFrontAnimCharSet, 0, wiperFrontAnimSpeedScale);
			self.wiperFrontAnimDuration = getAnimClipDuration(self.wiperFrontAnimCharSet, clip);
		end;
	end;
	self.iswiperFrontActive = false;
	self.finishwiperFront = true;
	--------------------------REAR WIPER ANIMATION----------------------
	local wiperBackAnimRootNode = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.wiperBack#rootNode"));
	self.wiperBackAnimCharSet = 0;
	if wiperBackAnimRootNode ~= nil and wiperBackAnimRootNode ~= 0 then
		self.wiperBackAnimCharSet = getAnimCharacterSet(wiperBackAnimRootNode);
		if self.wiperBackAnimCharSet ~= 0 then
			local clip = getAnimClipIndex(self.wiperBackAnimCharSet, getXMLString(xmlFile, "vehicle.wiperBack#clip"));
			assignAnimTrackClip(self.wiperBackAnimCharSet, 0, clip);
			setAnimTrackLoopState(self.wiperBackAnimCharSet, 0, true);
			local wiperBackAnimSpeedScale = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.wiperBack#speedScale"), 1);
			setAnimTrackSpeedScale(self.wiperBackAnimCharSet, 0, wiperBackAnimSpeedScale);
			self.wiperBackAnimDuration = getAnimClipDuration(self.wiperBackAnimCharSet, clip);
		end;
	end;
	self.iswiperBackActive = false;
	self.finishwiperBack = true;
	-------------------------PEDALI-------------------------
	local PedaleGasNode = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.PedaleGas#index"));
    if PedaleGasNode ~= nil then
        self.PedaleGas = {};
        self.PedaleGas.node = PedaleGasNode;
		self.PedaleGas.maxSpeed = getXMLInt(xmlFile, "vehicle.PedaleGas#maxSpeed");
		local x1,y1,z1 = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.PedaleGas#minRot"));
		local x2,y2,z2 = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.PedaleGas#maxRot"));
		self.PedaleGas.rotMin = {math.rad(Utils.getNoNil(x1,0)),math.rad(Utils.getNoNil(y1,0)),math.rad(Utils.getNoNil(z1,0))};
		self.PedaleGas.rotMax = {math.rad(Utils.getNoNil(x2,0)),math.rad(Utils.getNoNil(y2,0)),math.rad(Utils.getNoNil(z2,0))};
    end;
	
	self.PedaleFrizione = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.PedaleFrizione#index"));
	self.PedaleFreno = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.PedaleFreno#index"));
	
	-------------------------- LEVE ----------------------
	-- self.levaindicatori = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.levaindicatori#index"));
	self.LevaHandbrake = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.LevaHandbrake#index"));
	 
	--------------------------LED-------------------------
	self.handbrakelight = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.handbrakelight#index"));
	self.olioicona = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.olioicona#index"));
	self.tachiicona = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.tachiicona#index"));
    self.LedHazard = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.LedHazard#index"));
    self.ledLampeggiante = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.ledLampeggiante#index"));
	self.LedStart = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.LedStart#index"));
	self.Hire = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.Hire#index"));
	self.Green = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.Green#index"));
	self.quadroOFF = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.quadroOFF#index"));
	self.ledFrontwork = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.ledFrontwork#index"));
	self.ledRearwork = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.ledRearwork#index"));
    self.led4WDon = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.Led4WDon#index"));
    self.led4WDoff = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.Led4WDoff#index"));
	self.led4WDoff2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.Led4WDoff2#index"));
	self.LedBraccio = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.LedBraccio#index"));
	self.PTOLed = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.PTOLed#index"));
	
	self.frontled = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.frontled#index"));
	self.reverseled = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.reverseled#index"));
	------------------ SWITCHES---------------
	self.numSwitches = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.switches#count"),0);
	self.switch = {};
	for i=1, self.numSwitches do
		local objname = string.format("vehicle.switches.switch" .. "%d", i);
		self.switch[i] = {};
		self.switch[i] = Utils.indexToObject(self.components, getXMLString(xmlFile, objname .. "#index"));
	end;
	----------------- GASOLIO INDICATORI----------
	self.fuelIndicatorsGroup = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fuelIndicators#index"));
	self.numFuelIndicators = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.fuelIndicators#count"), 0);
	self.fuelIndicators = {};
    for i=1, self.numFuelIndicators do
        local objname = string.format("vehicle.fuelIndicators.fuelIndicator" .. "%d", i);
		self.fuelIndicators[i] = {};
        self.fuelIndicators[i].rotNode = Utils.indexToObject(self.components, getXMLString(xmlFile, objname .. "#rotNode"));
		setVisibility(self.fuelIndicators[i].rotNode,true);
    end;
	----------------- ROTORE LAMPEGGIANTE----------
	self.RotoreLampe1 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.RotoreLampe1#index"));
	self.RotoreLampe2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.RotoreLampe2#index"));
	--------------------PARAFANGHI------------------
	-- self.fender = {};
	-- self.fender.leftNode = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fender#leftIndex"));
	-- self.fender.rightNode = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fender#rightIndex"));
	-- self.fender.leftRotMax = getXMLInt(xmlFile, "vehicle.fender#leftRotMax");
	-- self.fender.rightRotMax = getXMLInt(xmlFile, "vehicle.fender#rightRotMax");   

   --------------------  hide fender------------
	self.setFenderVisibility = SpecializationUtil.callSpecializationsFunction("setFenderVisibility");
	self.fenders = {};
	self.fenders.rear = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fenders#index"));
	

	 --------------------------GIUNTI ASSALE------------------------
	self.giuntoDestro = {};
	self.giuntoDestro.node = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.giuntoDestro#index"));
	self.giuntoDestro.speedFactor = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.giuntoDestro#speedFactor"), 2);
	self.giuntoSinistro = {};
	self.giuntoSinistro.node = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.giuntoSinistro#index"));
	self.giuntoSinistro.speedFactor = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.giuntoSinistro#speedFactor"), 2);
	-----------------SOUND RISERVA------------------
    fuelwarningSoundFile = Utils.getFilename("Sound/fuelwarning.wav", self.baseDirectory);
    self.fuelwarningSoundId = createSample("fuelwarningSound");
    loadSample(self.fuelwarningSoundId, fuelwarningSoundFile, false);
    self.fuelwarningPlaying = false;
	self.playedSound = false;
	

	
end;
function JD7RSeries:delete()

end;
function JD7RSeries:readStream(streamId, connection)
end;
function JD7RSeries:writeStream(streamId, connection)
end;
function JD7RSeries:readUpdateStream(streamId, timestamp, connection)
	if connection:getIsServer() then
		if streamReadBool(streamId) then
		end;
	end;
end;
function JD7RSeries:writeUpdateStream(streamId, connection, dirtyMask)
	if not connection:getIsServer() then
		if streamWriteBool(streamId, bitAND(dirtyMask, self.vehicleDirtyFlag) ~= 0) then
        end;
    end;
end;
function JD7RSeries:mouseEvent(posX, posY, isDown, isUp, button)
end;

function JD7RSeries:setFenderVisibility(isVisible)
	setVisibility(self.fenders.rear, isVisible);
end;
function JD7RSeries:keyEvent(unicode, sym, modifier, isDown)
	
end;

function JD7RSeries:FrizioneFrenoRotation(dt, acceleration)
	-- if self.PedaleFrizione ~= nil then
		-- local FrizioneActive = false;
		-- if acceleration > 0 then
			-- FrizioneActive = true;
		-- end;

		-- local FrizioneMax = {};
		-- FrizioneMax[1] = math.rad(-52);
		-- FrizioneMax[2] = math.rad(0);
		-- FrizioneMax[3] = math.rad(0);
		-- local FrizioneRotationTime = 200;

		-- local FrizioneMin = {};
		-- FrizioneMin[1] = math.rad(-30);
		-- FrizioneMin[2] = math.rad(0);
		-- FrizioneMin[3] = math.rad(0);

		-- local x, y, z = getRotation(self.PedaleFrizione);
		-- local rot = {x,y,z};
		-- local newRot = Utils.getMovedLimitedValues(rot, FrizioneMin, FrizioneMax, 3, FrizioneRotationTime, dt, FrizioneActive);
		-- setRotation(self.PedaleFrizione, unpack(newRot));
	-- end;

	-- if self.PedaleFreno ~= nil then
		-- local brakeActive = false;
		-- if acceleration > 0 then
			-- brakeActive = true;
		-- end;

		-- local brakeMax = {};
		-- brakeMax[1] = math.rad(-22);
		-- brakeMax[2] = math.rad(0);
		-- brakeMax[3] = math.rad(0);
		-- local brakeRotationTime = 500;

		-- local brakeMin = {};
		-- brakeMin[1] = math.rad(0);
		-- brakeMin[2] = math.rad(0);
		-- brakeMin[3] = math.rad(0);

		-- local x, y, z = getRotation(self.PedaleFreno);
		-- local rot = {x,y,z};
		-- local newRot = Utils.getMovedLimitedValues(rot, brakeMin, brakeMax, 3, brakeRotationTime, dt, brakeActive);
		-- setRotation(self.PedaleFreno, unpack(newRot));
	-- end;
end;


function JD7RSeries:update(dt)
	-------------LIFT-HIDRO----------------
	if self:getIsActive() then
		
     ------------------LAMPEGGIANTI------------------
	    if self.beaconLightsActive then
			rotate(self.RotoreLampe1, 0, self.beaconLights[1].speed*dt, 0);
			rotate(self.RotoreLampe2, 0, self.beaconLights[2].speed*dt, 0);
		end;
		
	--------------------------GIUNTI ASSALE------------------------
		local x,y,z = getRotation(self.wheels[1].driveNode);
		setRotation(self.giuntoDestro.node, 0 ,0, x*self.giuntoDestro.speedFactor);
		local x,y,z = getRotation(self.wheels[1].driveNode);
		setRotation(self.giuntoSinistro.node, 0 ,0, x*self.giuntoSinistro.speedFactor);
		
		
		if self:getIsActive() then
		for _, part in pairs(self.movingParts) do
			Cylindered.setDirty(self, part);
		end;
	end;
	end;

	------------------LED RISERVA----------------------
	if self.isEntered then
		if self.fuelFillLevel < 60 then
			self.riserva = self.riserva - dt;
			if self.playedSound == false then
				playSample(self.fuelwarningSoundId,1,1,0);
				self.playedSound = true;
			end;
			self.ledriservaActive = true;
		else
			self.playedSound = false;
			self.ledriservaActive = false;
		end;
		setVisibility(self.ledriserva,self.ledriservaActive);
		self:updateFuelIndicators();
	end;

	
	---------------------CAM INTERNA MOBILE---------------------
     if self.camIndex == 1 then
	 if self:getIsActive() then
		if InputBinding.isPressed(InputBinding.MOVECAMLEFT2) then
			self.camPositionX = self.camPositionX + 0.03;
			if self.camPositionX >= 0.3 then
				self.camPositionX = 0.3;
			end;
		end;
		if InputBinding.isPressed(InputBinding.MOVECAMRIGHT2) then
			self.camPositionX = self.camPositionX - 0.03;
			if self.camPositionX <= -0.3 then
				self.camPositionX = -0.3;
			end;
		end;
		if InputBinding.isPressed(InputBinding.MOVECAMFORWARD2) then
			self.camPositionZ = self.camPositionZ + 0.03;
			if self.camPositionZ >= 0.3 then
				self.camPositionZ = 0.3;
			end;
		end;
				if InputBinding.isPressed(InputBinding.MOVECAMBACK2) then
			self.camPositionZ = self.camPositionZ - 0.03;
			if self.camPositionZ <= -0.22 then
				self.camPositionZ = -0.22;
			end;
		end;
		if Input.isMouseButtonPressed(Input.MOUSE_BUTTON_WHEEL_UP) then
			self.camPositionY = self.camPositionY + 0.02;
			if self.camPositionY >= 0.15 then
				self.camPositionY = 0.15;
			end;
		end;
		if Input.isMouseButtonPressed(Input.MOUSE_BUTTON_WHEEL_DOWN) then
			self.camPositionY = self.camPositionY - 0.02;
			if self.camPositionY <= -0.2 then
				self.camPositionY = -0.2;
			end;
		end;
		if Input.isKeyPressed(Input.KEY_z) then
			self.camPositionX = 0;
			self.camPositionZ = 0;
			self.camPositionY = 0;
		end;
		if self.internalCamera ~= nil then
			setTranslation(self.internalCamera, self.camPositionX, self.camPositionZ, self.camPositionY);
		end;
   	end;
	end;
	--------------REALISTIC INDOOR CAM------------------------
	if self:getIsActive() then
			local ax, ay, az = getWorldTranslation(self.ric.directionPart);
			local bx = 0;
			local by = 1100000;
			local bz = 0;
			x, y, z = worldDirectionToLocal(getParent(self.ric.directionPart), bx-ax, by-ay, bz-az);
			setDirection(self.ric.directionPart, x, y, z, 0, 0, 1);

	end;
	
	if self:getIsActive() then
		if self.isHired == true then
			setVisibility(self.Hire, true);
			setVisibility(self.Green, false);
		else
			setVisibility(self.Hire, false);
			setVisibility(self.Green, true);
		end;
	end;


	
end;
function JD7RSeries:loadFromAttributesAndNodes(xmlFile, key, resetVehicles)
    return BaseMission.VEHICLE_LOAD_OK;
end;
function JD7RSeries:updateTick(dt)
    if self.isMotorStarted then
			setVisibility(self.olioicona, false);
			setVisibility(self.tachiicona, true);
		  	setVisibility(self.LedStart, true);
			setVisibility(self.quadroOFF, true);
			
			setVisibility(self.fuelIndicatorsGroup, true);
			setVisibility(self.LedBraccio, true);
		else
			
			setVisibility(self.olioicona, true);
			setVisibility(self.tachiicona, false);
			setVisibility(self.LedStart, false);
		    setVisibility(self.quadroOFF, false);
			
			setVisibility(self.fuelIndicatorsGroup, false);
			setVisibility(self.LedBraccio, false);
		end;
	if self:getIsActive() then
		
		for k, implement in pairs(self.attachedImplements) do
				if implement.object ~= nil then
					if implement.object.isTurnedOn then
						setVisibility(self.PTOLed, true);
					else
						setVisibility(self.PTOLed, false);
					end;
				end;				
		end;
		-------------------PEDALI--------------------------------
		
			 if self.PedaleGas ~= nil then
				local percent = (self.lastSpeed*self.speedDisplayScale*3600) / self.PedaleGas.maxSpeed;
				local minRot = self.PedaleGas.rotMin;
				local maxRot = self.PedaleGas.rotMax;
				local x = minRot[1] + (maxRot[1] - minRot[1]) * percent;
				local y = minRot[2] + (maxRot[2] - minRot[2]) * percent;
				local z = minRot[3] + (maxRot[3] - minRot[3]) * percent;
				setRotation(self.PedaleGas.node, x, y, z);
	        end;
				
	self:FrizioneFrenoRotation(dt, acceleration);
	end;


	
	----------- WIPERS -----------------
	if self.isMotorStarted then
		if not self.finishwiperFront then
			if getAnimTrackTime(self.wiperFrontAnimCharSet, 0) % self.wiperFrontAnimDuration <= 100 then
				setAnimTrackTime(self.wiperFrontAnimCharSet, 0, 0.0);
				disableAnimTrack(self.wiperFrontAnimCharSet, 0);
				self.finishwiperFront = true;
			end;
		end;
		if g_currentMission.environment.lastRainScale > 0.1 and g_currentMission.environment.timeSinceLastRain < 30 then
			if not self.iswiperFrontActive then
				enableAnimTrack(self.wiperFrontAnimCharSet, 0);
				self.iswiperFrontActive = true;
			end;
		else
			if self.iswiperFrontActive then
				self.iswiperFrontActive = false;
				self.finishwiperFront = false;
			end;
		end;
		
		if not self.finishwiperBack then
			if getAnimTrackTime(self.wiperBackAnimCharSet, 0) % self.wiperBackAnimDuration <= 100 then
				setAnimTrackTime(self.wiperBackAnimCharSet, 0, 0.0);
				disableAnimTrack(self.wiperBackAnimCharSet, 0);
				self.finishwiperBack = true;
			end;
		end;
		if g_currentMission.environment.lastRainScale > 0.1 and g_currentMission.environment.timeSinceLastRain < 30 then
			if not self.iswiperBackActive then
				enableAnimTrack(self.wiperBackAnimCharSet, 0);
				self.iswiperBackActive = true;
			end;
		else
			if self.iswiperBackActive then
				self.iswiperBackActive = false;
				self.finishwiperBack = false;
			end;
		end;
		for _, part in pairs(self.movingParts) do
			part.isDirty = true;
		end;
	end;
	--------------------SWITCH------------------------------

	if self.switch[1] ~= nil then
		if self.isMotorStarted then
			setRotation(self.switch[1], math.rad(0), math.rad(0), math.rad(-60));
		else
			setRotation(self.switch[1], math.rad(0), math.rad(0), math.rad(0));
		end;
	end;
	if self.handbrakelight ~= nil then
		if self.driveControl.handBrake.isActive then
			setVisibility(self.handbrakelight, true);
		else
			setVisibility(self.handbrakelight, false);
		end;
	end
	-- if self.ledFrontwork ~= nil then
		 -- local i = 1
		 -- if self.B3.work[i].a then
			-- setVisibility(self.ledFrontwork, true);
		-- else
			-- setVisibility(self.ledFrontwork, false);
		-- end;
	-- end;
	-- if self.ledRearwork ~= nil then
		 -- local i = 2
		 -- if self.B3.work[i].a then
			-- setVisibility(self.ledRearwork, true);
		-- else
			-- setVisibility(self.ledRearwork, false);
		-- end;
	-- end;
	    --------- Levers rotations--------------
	-- if self.levaindicatori ~= nil then
		-- if not self.B3.wl then
			-- if self.B3.dirRight[1].a then
				-- setRotation(self.levaindicatori, 0, math.rad(-20), math.rad(0));
			-- elseif self.B3.dirLeft[1].a then
				-- setRotation(self.levaindicatori, 0, math.rad(20), math.rad(0));
			-- else
				-- setRotation(self.levaindicatori, 0, 0, math.rad(0));
			-- end;
		-- else
			-- setRotation(self.levaindicatori, 0, 0, math.rad(0));
		-- end;
	-- end
	if self.LevaHandbrake ~= nil then
		if self.driveControl.handBrake.isActive then
			setTranslation(self.LevaHandbrake, 0, 0.03159, math.abs(0));
		  else
			setTranslation(self.LevaHandbrake, 0, 0.03159,  math.abs(0.02743));
		    if self.driveControl.shuttle.direction > 0 then		    
			setTranslation(self.LevaHandbrake, -0.01908, 0.03159,  math.abs(0.02834));
		else
			setTranslation(self.LevaHandbrake, -0.01908, 0.03159,  math.abs(0.00198));
			end;
		 end;	
	end;

	if self.LucePorta ~= nil and self.doorIObject ~= nil then
		setVisibility(self.LucePorta, self.doorIObject.isOpen);
	end;
	if self.ledLampeggiante ~= nil then
		 if self.beaconLightsActive then
		    setVisibility(self.ledLampeggiante, true);
		 else
		   setVisibility(self.ledLampeggiante, false);
		end;
	end;

end;


function JD7RSeries:updateFuelIndicators()
	local amountOfFuelPerIndicator = self.fuelCapacity/11;
	local timesToIterate = self.fuelFillLevel/amountOfFuelPerIndicator;
	timesToIterate = math.floor(timesToIterate);
	if self.oldTimesToIterate ~= timesToIterate then
		for i=1, self.numFuelIndicators do
			setVisibility(self.fuelIndicators[i].rotNode, false);
		end;
		for i=1, timesToIterate do
			setVisibility(self.fuelIndicators[i].rotNode, true);
		end;
	end;
	self.oldTimesToIterate = timesToIterate;
end;
function JD7RSeries:draw()

	if self.driveControl.shuttle.isActive then
			if self.driveControl.shuttle.direction > 0 then
				g_currentMission:addHelpButtonText(g_i18n:getText("Inversore_control_forwards"), InputBinding.CAMBIA_DIREZIONE);
				setVisibility(self.frontled, true);
				 setVisibility(self.reverseled, false);
			else
				g_currentMission:addHelpButtonText(g_i18n:getText("Inversore_control_backwards"), InputBinding.CAMBIA_DIREZIONE);
				setVisibility(self.reverseled, true);
				  setVisibility(self.frontled, false);
			end;
	end;
	if self.isEntered then
		if self.driveControl.handBrake.isActive then
			if Input.isKeyPressed(Input.KEY_w) then
				g_currentMission:addWarning(g_i18n:getText("handbrakeRELEASE"), 0.015, 0.030);
				g_currentMission:addHelpButtonText(g_i18n:getText("driveControlHandbrake"), InputBinding.driveControlHandbrake);
			end;
		end;
	end;
	if self.isEntered then
		if self.driveControl.handBrake.isActive then
			if Input.isKeyPressed(Input.KEY_s) then
				g_currentMission:addWarning(g_i18n:getText("handbrakeRELEASE"), 0.015, 0.030);
				g_currentMission:addHelpButtonText(g_i18n:getText("driveControlHandbrake"), InputBinding.driveControlHandbrake);
			end;
		end;
	end;
	if self.isEntered then
		if not self.driveControl.manMotorStart.isMotorStarted then
			if self.driveControl.manMotorStart.startCnt > 0 then
				g_currentMission:addWarning(g_i18n:getText("jd_START"), 0.015, 0.030);
			else
				g_currentMission:addWarning(g_i18n:getText("pre_hat"), 0.015, 0.030);
		end;
		end;
		end;
end;


function JD7RSeries:onEnter()
        if self.isMotorStarted then
			setVisibility(self.olioicona, false);
			setVisibility(self.tachiicona, true);
			setVisibility(self.LedStart, true);
			setVisibility(self.quadroOFF, true);
		else
			setVisibility(self.olioicona, true);
			setVisibility(self.tachiicona, false);
			setVisibility(self.LedStart, false);
			setVisibility(self.quadroOFF, false);
		end
	if self.iswiperFrontActive then
		enableAnimTrack(self.wiperFrontAnimCharSet, 0);
	end;
		if self.iswiperBackActive then
		enableAnimTrack(self.wiperBackAnimCharSet, 0);
	end;

	
end;
function JD7RSeries:onLeave()
	    if self.isMotorStarted then
			setVisibility(self.olioicona, false);
			setVisibility(self.tachiicona, true);
			setVisibility(self.LedStart, true);
			setVisibility(self.quadroOFF, true);
	
		else
			setVisibility(self.olioicona, true);
			setVisibility(self.tachiicona, false);
			setVisibility(self.LedStart, false);
			setVisibility(self.quadroOFF, false);
			
	     end
	if self.iswiperBackActive then
		disableAnimTrack(self.wiperBackAnimCharSet, 0);
	end;
	    if self.iswiperFrontActive then
		disableAnimTrack(self.wiperFrontAnimCharSet, 0);
	end;
	
end;

